const mqtt = require('mqtt');
const { MongoClient, ServerApiVersion } = require('mongodb');

const options = {
    // Clean session
    clean: true,
    connectTimeout: 4000,
    // Authentication
    clientId: 'svelte-mqtt',
    username: 'pooh',
    password: '4r*D.~*?wB*>3jBm'
};

const uri = "mongodb+srv://pooh:hnamDbKGYN2lmuqE@pooh.dnhlmdo.mongodb.net/?retryWrites=true&w=majority";
const client = new MongoClient(uri, { useNewUrlParser: true, useUnifiedTopology: true, serverApi: ServerApiVersion.v1 });
client.connect(err => {
    console.log(err);
}).then(() => console.log("connected to mongodb"));

const mqttClient = mqtt.connect('ws://34.143.162.7:9001/mqtt', options);

mqttClient.on('connect', () => {
    mqttClient.subscribe('app/#');
    mqttClient.subscribe('lpg');
    console.log("connected to mqtt")
});

mqttClient.on('message', (topic, message) => {
    if(topic == 'lpg'){
        let data = parseInt(message);
        if(data > 1000){
            fetch(`https://api.line.me/v2/bot/message/broadcast`, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Authorization': 'Bearer SGchAFhZCOS9UKgEK18w3pffiSmMkFyWlC/fYilBSAsKn0PL7mJX3hEXN+CjlzcUljzG7erFqKTIMT5uj4uPoyzpDrutDPXILeN7id9EGrA5xfVg3uekxwW4qu4MJoRRD+nkBb/LKkFXJdTyiArtygdB04t89/1O/w1cDnyilFU='
                },
                body: JSON.stringify(alertMessage)
            })
        }
    }
    console.log(topic, message.toString());
    let appTopic = topic.split("/").slice(1).join("");
    // console.log(appTopic);
    if (message.toString() == "") return;
    client.db('MQTT').collection(appTopic).insertOne({
        payload: message.toString(),
        time: new Date(),
    });
});

let MQTTrequests = client.db('MQTT').collection('mqtt write').watch();

MQTTrequests.on('change', next => {
    if (next.operationType != "insert") { return; }
    // console.log(next.fullDocument);
    mqttClient.publish(next.fullDocument.topic, next.fullDocument.payload);
    client.db('MQTT').collection('mqtt write').deleteOne({ _id: next.fullDocument._id });
    // console.log(next.fullDocument);
});